<?php

namespace App\Models;

use App\Services\Util;
use Illuminate\Database\Eloquent\Model;

/**
 * App\Models\Attribute
 *
 * @property int $id
 * @property int|null $parent_id
 * @property string $name
 * @property array|null $trans_name
 * @property int|null $pos
 * @property int $active
 * @property \Illuminate\Support\Carbon|null $created_at
 * @property \Illuminate\Support\Carbon|null $updated_at
 * @property-read \Illuminate\Database\Eloquent\Collection|\App\Models\Attribute[] $childrens
 * @property-read \App\Models\Attribute|null $parent
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereActive($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereCreatedAt($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereName($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereParentId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute wherePos($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereTransName($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereUpdatedAt($value)
 * @property string|null $slug
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute whereSlug($value)
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute newModelQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute newQuery()
 * @method static \Illuminate\Database\Eloquent\Builder|\App\Models\Attribute query()
 * @property-read int|null $childrens_count
 * @property int $attribute_type_id
 * @property string|null $value
 * @property-read \App\Models\AttributeType $attribute_type
 * @method static \Illuminate\Database\Eloquent\Builder|Attribute whereAttributeTypeId($value)
 * @method static \Illuminate\Database\Eloquent\Builder|Attribute whereValue($value)
 * @mixin \Eloquent
 */
class Attribute extends Model
{
    protected $table = 'attributes';

    protected $casts = [
        'parent_id' => 'int',
		'pos' => 'int',
		'active' => 'bool',
		'trans_name' => 'array',
    ];


	protected $fillable = [
		'parent_id',
        'attribute_type_id',
		'name',
        'value',
		'trans_name',
		'pos',
		'active',
		'slug'
	];

    public function attribute_type()
    {
        return $this->belongsTo(AttributeType::class, 'attribute_type_id');
    }

    public function parent()
    {
        return $this->belongsTo(Attribute::class, 'parent_id');
    }

    public function childrens()
    {
        return $this->hasMany(Attribute::class, 'parent_id', 'id');
    }

    public function setPosAttribute($value){
        $this->attributes['pos'] = is_numeric($value) ? $value : null;
    }

    public function getFormattedValue()
    {
       // return isset($this->attributes['value']) ? Util::formatNumber($this->attributes['value']) : "";
    }
    
    public function getLang($key)
    {
        $lang = \App::getLocale();
        if ($lang == 'de') {
            return $this->{$key};
        }
        $trans = $this->getTrans($key, $lang);
        if (!$trans || $trans == '') {
            return $this->{$key};
        }
        return $trans;
    }

    public function getTrans($key, $lang)
    {
        $key = 'trans_' . $key;
        if (!empty($this->{$key}[$lang])) {
            return $this->{$key}[$lang];
        }
    }

    public function getTranNames()
    {
        $ret = "";
        foreach ((array) $this->trans_name as $value){
            $ret .= $value.', ';
        }
        return rtrim($ret, ', ');
    }

}
